// SDK.Control_Surfaces.c
// Copyright (c) 1997 Microsoft Corporation.  All rights reserved.
//
// Copied from Lear 45 control surfaces indicators
//

#include	"gauges.h"
#include	"SDK.Control_Surfaces.h"

//	Set up import and export tables and gauge header
char		gauge_name[]		= "Generic.Control_Surfaces.lg_trim\0";
extern PELEMENT_HEADER		list;
MODULE_SETUP( GAUGE_HEADER_VERSION, 115, gauge_name, &list );


MAKE_SLIDER(	slider_trim,
				BMP_TRIM,
				NULL,
				NULL,
				IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
				0,
				{18,44},

				MODULE_VAR_NONE, NULL, 0,
				ELEVATOR_TRIM_IND, NULL, -75.0/32768.0 )

MAKE_SLIDER(	slider_ailerons,
				BMP_CS_AILERONS,
				NULL,
				NULL,
				IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
				0,
				{96, 5},

				YOKE_IND_X, NULL, 73.0/32768.0,
				MODULE_VAR_NONE, NULL, 0 )

MAKE_SLIDER(	slider_elevator,
				BMP_CS_ELEVATOR,
				NULL,
				NULL,
				IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
				0,
				{100, 43},
				MODULE_VAR_NONE, NULL, 0,
				YOKE_IND_Y, NULL, -60.0/32768.0 )

MAKE_SLIDER(	slider_rudder,
				BMP_CS_RUDDER,
				NULL,
				NULL,
				IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
				0,
				{95, 84},

				RUDDER_PEDAL_IND, NULL, 72.0/32768.0,
				MODULE_VAR_NONE, NULL, 0 )

PELEMENT_HEADER		plist[] =
{
	&slider_trim.header,
	&slider_ailerons.header,
	&slider_elevator.header,
	&slider_rudder.header,
	NULL
};

MAKE_STATIC( 	background,
				BMP_BACKGROUND,
				&plist,
				NULL,
				IMAGE_USE_TRANSPARENCY,
				0,
				{0,0} )

PELEMENT_HEADER		list	= &background.header;


MOUSE_BEGIN( mouse_rect, HELP_NONE, 0, 0 )
	MOUSE_PARENT( 0,0,44,94,	HELPID_LEAR_TRIM )
	MOUSE_PARENT( 60,0,76,16,	HELPID_LEAR_AILERON )
	MOUSE_PARENT( 82,16,32,62,	HELPID_LEAR_ELEVATOR )
	MOUSE_PARENT( 60,78,76,16,	HELPID_LEAR_RUDDER )
MOUSE_END


//---------------------------------------------------------------------------
void FSAPI	install_routine( HINSTANCE resource_file_handle )
{
	element_list_install( list, resource_file_handle );
	mouse_list_install( mouse_rect, &gauge_header, &background.image_data.final->dim );
	mouse_list_register( mouse_rect, &gauge_header );
}


//---------------------------------------------------------------------------
void FSAPI	initialize_routine()
{
	element_list_initialize( list );
}


//---------------------------------------------------------------------------
void FSAPI	update_routine()
{
	element_list_update( list );
}


//---------------------------------------------------------------------------
void FSAPI	generate_routine( GENERATE_PHASE phase )
{
	element_list_generate( list, phase );
}


//---------------------------------------------------------------------------
void FSAPI	draw_routine()
{
	element_list_plot( list );
}


//---------------------------------------------------------------------------
void FSAPI	kill_routine()
{
	mouse_list_unregister( mouse_rect, &gauge_header );
	element_list_kill( list );
}

