// SDK.Fuel.c
// Copyright (c) 1997 Microsoft Corporation.  All rights reserved.
//
// Copied from Bell 206B fuel gauge
//

#include	"gauges.h"
#include	"SDK.Fuel.h"

//	Set up import and export tables and gauge header
char						gauge_name[]		= "SDK.Fuel\0";
extern	PELEMENT_HEADER		list;
MODULE_SETUP( GAUGE_HEADER_VERSION, 57, gauge_name, &list )


#define	GAUGE_MIN_FUEL	0
#define	GAUGE_MAX_FUEL	75

NONLINEARITY  nonlinearity[] =
{
	{{53,	219},	 0, 0},
	{{119,	 47},	25, 0},
	{{246,	 93},	50, 0},
	{{241,	221},	75, 0}
};


FAILURE_RECORD	fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL, FAIL_ACTION_ZERO},
	{FAIL_GAUGE_FUEL_INDICATORS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

MODULE_VAR_CB	fuel_cb;


MAKE_NEEDLE(	needle,
				BMP_NEEDLE,
				NULL,
				fail,
				IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
				0,
				{150, 150},
				{6, 12},
				{111, 12},
				FUEL_QUANTITY_CENTER,
				fuel_cb,
				nonlinearity,
				6 )


PELEMENT_HEADER		plist1[] =
{
	(PELEMENT_HEADER)&needle,
	NULL
};


MAKE_STATIC(	background,
				BMP_BACKGROUND,
				&plist1,
				fail,
				IMAGE_USE_TRANSPARENCY,
				0,
				{9, 0} )

PELEMENT_HEADER		list	= &background.header;



MOUSE_BEGIN( mouse_rect, HELPID_BELL_FUEL_QTY, 0, 0 )
MOUSE_END


//---------------------------------------------------------------------------
FLOAT64 FSAPI fuel_cb( PMODULE_VAR var )
{
	FLOAT64	val = var->var_value.n;

	if (val > GAUGE_MAX_FUEL)
		val = GAUGE_MAX_FUEL;
	else if (val < GAUGE_MIN_FUEL)
		val = GAUGE_MIN_FUEL;

	return val;
}

//---------------------------------------------------------------------------
void FSAPI	install_routine( HINSTANCE resource_file_handle )
{
	element_list_install( list, resource_file_handle );
	mouse_list_install( mouse_rect, &gauge_header, &background.image_data.final->dim );
	mouse_list_register( mouse_rect, &gauge_header );
}


//---------------------------------------------------------------------------
void FSAPI	initialize_routine()
{
	element_list_initialize( list );
}


//---------------------------------------------------------------------------
void FSAPI	update_routine()
{
	element_list_update( list );
}


//---------------------------------------------------------------------------
void FSAPI	generate_routine( GENERATE_PHASE phase )
{
	element_list_generate( list, phase );
}


//---------------------------------------------------------------------------
void FSAPI	draw_routine()
{
	element_list_plot( list );
}


//---------------------------------------------------------------------------
void FSAPI	kill_routine()
{
	mouse_list_unregister( mouse_rect, &gauge_header );
	element_list_kill( list );
}

