// SDK.Wiskey.c
// Copyright (c) 1997 Microsoft Corporation.  All rights reserved.
//
// Copied from Extra wiskey compass gauge
//

#include	"gauges.h"
#include	"SDK.Wiskey.h"

//	Set up import and export tables and gauge header
char		gauge_name[]		= "SDK.Wiskey\0";
extern PELEMENT_HEADER		list;
MODULE_SETUP( GAUGE_HEADER_VERSION, 57, gauge_name, &list );


MODULE_VAR_CB	convert_x_var;
MODULE_VAR_CB	convert_y_var;

FAILURE_RECORD	fail[] =
{
	{FAIL_GAUGE_MAGNETIC_COMPASS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

MAKE_MOVING(	moving_card,
				BMP_CARD,
				NULL,
				fail,
				IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
				0,
				{22,41},

				WHISKEY_COMPASS_DEGREES, convert_x_var,
				0, 360,

				MODULE_VAR_NONE, convert_y_var,
				0, 0 )


PELEMENT_HEADER		plist[2] =
{
	&moving_card.header,
	NULL
};

MAKE_STATIC(	background,
				BMP_BACKGROUND,
				&plist,
				NULL,
				IMAGE_USE_TRANSPARENCY,
				0,
				{0,0} )

PELEMENT_HEADER		list	= &background.header;


MOUSE_BEGIN( mouse_rect, HELPID_EXTR_COMPASS, 0, 0 )
MOUSE_END


//---------------------------------------------------------------------------
FLOAT64 FSAPI	convert_x_var(PMODULE_VAR var)
{
	FLOAT64		val;

	val = 360.0-var->var_value.n;

	if( val >= 0 && val <= 360 )
		return val;
	else
		return 0;
}

FLOAT64 FSAPI	convert_y_var(PMODULE_VAR var)
{
	return 1.0;
}


//---------------------------------------------------------------------------
void FSAPI		install_routine( HINSTANCE resource_file_handle )
{
	element_list_install( list, resource_file_handle );
	mouse_list_install( mouse_rect, &gauge_header, &background.image_data.final->dim );
	mouse_list_register( mouse_rect, &gauge_header );
}


//---------------------------------------------------------------------------
void FSAPI		initialize_routine()
{
	element_list_initialize( list );
}


//---------------------------------------------------------------------------
void FSAPI		update_routine()
{
	element_list_update(list);
}


//---------------------------------------------------------------------------
void FSAPI		generate_routine( GENERATE_PHASE phase )
{
	element_list_generate( list, phase );
}


//---------------------------------------------------------------------------
void FSAPI		draw_routine()
{
	element_list_plot( list );
}


//---------------------------------------------------------------------------
void FSAPI		kill_routine()
{
	mouse_list_unregister( mouse_rect, &gauge_header );
	element_list_kill( list );
}

